<?
//  
//  Copyright (c) 2006, 2007		Dmitry Butskoy
//  					<buc@citadel.stu.neva.ru>
//  License:  GPL v2 or any later
//  
//  For full terms see the file COPYING.
//  

require("./common.php");


if ($S)  $cache = $CACHE_MAX_AGE;
else  $cache = 0;


if (isset($delete) && $delete == 1) {
    if ($CYRUS)
	// Cyrus/IMAP move deleted mails to Trash Folder
	imap_mail_move($mbox, $uid, $FOLDERTRASH, CP_UID);
    else 
	// other IMAP servers
	imap_delete ($mbox, $uid, ST_UID);

    imap_expunge ($mbox);

    unset($delete);

    $cache = 0;	//  just never cache "after-delete" lists...
    if ($S)  $S++;	//  incremet seq number to flush another cached pages
}


$num = imap_num_msg ($mbox);
$pages = ceil($num / $MAILSBYPAGE);
if (!isset($page) || $page == 0)
    $page = ceil(($num - imap_num_recent ($mbox) + 1) / $MAILSBYPAGE);
if ($page > $pages)
	$page = $pages;
$prev_page = $page - 1;
$next_page = $page + 1;


wmlstart($cache);

print "<card id=\"list\">\n";


/* an empty folder */
if ($page <= 0) {

	echo "<p><small><br/><br/>";
	echo _('This folder is empty') . ".";
	echo "</small></p>\n";

} else {

    $end = $page * $MAILSBYPAGE;
    $start = $end - $MAILSBYPAGE + 1;
    if ($end > $num)  $end = $num;

    if ($pages > 1) {
	if ($start == $end)  $str = $start;
	else  $str = $start . "-" . $end;

	echo "<p align=\"center\"><small>";
	echo "$str &nbsp; ($num) &nbsp; ";
	wmllink(_('pages'),"#pages",NULL);
	echo "</small></p>";
    }


    echo "<p mode=\"nowrap\"><small>";

    if ($start == $end)  $str = $start;
    else  $str = $start.":".$end;

    $infos = imap_fetch_overview ($mbox, $str);

    foreach ($infos as $info) {

	$fromlist = imap_rfc822_parse_adrlist($info->from, "unknown");
	$from = $fromlist[0]->mailbox . "@" . $fromlist[0]->host;
	$name = getheader($fromlist[0]->personal);
	if (!strcasecmp($name,$fromlist[0]->mailbox))
		$name = "";

	$subject = getheader($info->subject);
	if (empty($subject))  $subject = $EMPTY_SUBJ;

	$uid = $info->uid;

	if (!$info->seen)  echo "<b>";
	wmllink($subject,"#info",
		array("name"=>$name,"from"=>$from,
			"subj"=>$subject,"uid"=>$uid));
	if (!$info->seen)  echo "</b>";

	echo "<br/>";
    }

    echo "</small></p>\n";


    if ($page < $pages) {
	echo "<p align=\"center\"><small>\n";
	wmllink($NEXT_LINK,"list.php",array("page"=>$next_page));
	echo "</small></p>\n";
    }
}


imap_close($mbox);

if ($page < $pages)
    wmlbutton(_('Next'),"list.php",array("page"=>$next_page));

wmlbutton(_('INDEX'),"index.php",NULL);

if ($pages > 1)
    wmlbutton(_('Pages'),"#pages",NULL);

wmlbutton(_('Reload'),"list.php",array("page"=>$page),0,1);

echo "</card>\n";


if ($pages > 1) {
    echo "<card id=\"pages\">\n";
    echo "<p><small>"._('List').":<br/>\n";

    $max = $PAGESBYPAGE;

    if ($pages <= $max) {
	for ($i = 1; $i <= $pages; $i++)  $p[$i] = $i;
    }
    else {
	if ($max >= 5)
	    $p = array("1",$prev_page,$page,$next_page,$pages);
	else
	    $p = array("1",$page,$pages);
	$p = array_unique($p);
	asort($p);
    }

    foreach ($p as $i) {
	if ($i == 0 || $i > $pages)  continue;

	$end = $i * $MAILSBYPAGE;
	$start = $end - $MAILSBYPAGE + 1;
	if ($end > $num)  $end = $num;

	if ($start == $end)  $str = $start;
	else  $str = $start . "-" . $end;

	if ($pages > $max)  $str = $i . ": " . $str;

	if ($i == $page)
	    echo "<b>$str</b>";    
	else
	    wmllink($str,"list.php",array("page"=>$i));
	echo "<br/>\n";
    }

    if ($pages > $max) {
	if ($page > 1)  $val = $prev_page;
	else  $val = $next_page;
	echo _('Page number') . ":<br>";
	echo "<input format=\"*N\" size=\"7\" name=\"page\" value=\"$val\"/>\n";
	wmllink(_('Go'),"list.php",array("page"=>"$(page)"));
    }

    echo "</small></p>\n";

    wmlbutton(_('BACK'),"#list",NULL);

    echo "</card>\n";
}

echo "<card id=\"info\">\n";
echo "<p mode=\"wrap\"><small>\n";

echo "<b>"._('From').":</b> $(from)<br/>\n";
echo "<b>"._('Name').":</b> $(name)<br/>\n";
echo "<b>"._('Subj').":</b> $(subj)<br/>\n";
wmllink(_('Read'),"view.php",array("part"=>1,"attid"=>0,
				"page"=>$page,"uid"=>"$(uid)"));
echo "<br/>\n";
wmllink(_('Delete'),"list.php",array("page"=>$page,"uid"=>"$(uid)","delete"=>1));
echo "<br/>\n";
wmllink(_('Reply'),"compose.php",array("page"=>$page,"uid"=>"$(uid)"));
echo "<br/>\n";
wmllink(_('Forward'),"compose.php",array("page"=>$page,"uid"=>"$(uid)","fwd"=>1));
echo "<br/>\n";

echo "</small></p>";

wmlbutton(_('BACK'),"#list",NULL);

wmlbutton(_('Delete'),"list.php",array("page"=>$page,"uid"=>"$(uid)","delete"=>1));
wmlbutton(_('Reply'),"compose.php",array("page"=>$page,"uid"=>"$(uid)"));
wmlbutton(_('Forward'),"compose.php",array("page"=>$page,"uid"=>"$(uid)","fwd"=>1));

echo "</card>\n";

wmlend();
?>
