<?
//  
//  Copyright (c) 2006, 2007		Dmitry Butskoy
//  					<buc@citadel.stu.neva.ru>
//  License:  GPL v2 or any later
//  
//  For full terms see the file COPYING.
//  

require("./common.php");


$info = imap_fetch_overview ($mbox, "$uid", FT_UID);

$fromlist = imap_rfc822_parse_adrlist($info[0]->from, "unknown");
$from = $fromlist[0]->mailbox . "@" . $fromlist[0]->host;
$name = getheader($fromlist[0]->personal);
if (!strcasecmp($name,$fromlist[0]->mailbox))
	$name = "";

$subject = getheader($info[0]->subject);
if (empty($subject))  $subject = $EMPTY_SUBJ;

$msgdate = date("d/m/y H:i:s", strtotime($info[0]->date));


if (empty($part))  $part = 1;
if (empty($attid))  $attid = 0;

$prev_part = $part - 1;
$next_part = $part + 1;


$structure = imap_fetchstructure($mbox, $uid, FT_UID);
if (!$structure)  wmldie ("imap_fetchstructure: " . imap_last_error());


$num_att = 0;

$B = getmsgbody($mbox, $uid, $structure, $attid);
$bodysize = strlen($B);

if (!$attid) {
    $attaches = getattaches($mbox, $uid, $structure);
    $num_att = count($attaches);
}

imap_close($mbox);


if ($num_att > 0) {
    /*  Be careful -- '\n' marks here where the page splitting may be done!  */

    $B .= "<fieldset></fieldset>";
    $B .= "<b>"._('Attachments').":</b> <br/>";

    foreach ($attaches as $idx => $att) {
	$kb = ceil($att->bytes / 1024) . "k";
	$type = type2str($att->type);
	if (!empty($att->subtype))  $type = $type . "/" . $att->subtype;

	$B .= "\n";
	$B .= "<b>"._('Name').":</b> $att->name<br/>";
	$B .= "<b>"._('Type').":</b> $type<br/>";
	$B .= "<b>"._('Size').":</b> $kb<br/>";

	if ($att->type == TYPETEXT || $att->type == TYPEMESSAGE) {
	    $B .= get_wmllink(_('View'),"view.php",
				array("part"=>1,"attid"=>$att->part,
					"page"=>$page,"uid"=>$uid));
	    $B .= "<br/>";
	}
	$B .= get_wmllink(_('Download'),"download.php/".$att->name,
			    array("attid"=>$att->part,
				    "page"=>$page,"uid"=>$uid));
	$B .= "<br/><br/>";
    }

    $fullsize = strlen($B);	    //  with optional attachment list
}


$topsize = 0;
if (!$attid) {
    $topsize = strlen("<b></b>: <b></b>: <b></b>: <b></b>: : : "._('From')._('Name')._('Subj')._('Date')._('Size')._('Attachments'));
    $topsize += strlen($from.$fromname.$subject.$msgdate."10000"."maybe\n");
    if ($topsize > $PAGESIZE)  wmldie("too low maxsize $PAGESIZE");
}


$parts = 1;
$poses = array();
$poses[1] = 0;

$pos = $PAGESIZE - $topsize;	// presevre space for the 1st page headers...
while (($next = strpos($B, " ", $pos)) !== false &&
	$next < $bodysize
) {
	$parts++;
	$poses[$parts] = $next;
	$pos = $next + $PAGESIZE;
}
$poses[$parts + 1] = $bodysize;


if ($num_att) {		//  have attachments' list
    if ($poses[$parts] + $PAGESIZE >= $fullsize) {
	//  att list fits in the last page
	$poses[$parts + 1] = $fullsize;
	$attpart = $parts;
    } else {	//  more clear to start from the new page...
	$parts++;
	$poses[$parts] = $bodysize;	//  paranoia
	$attpart = $parts;

	//  Note: split by '\n' here!...
	$pos = $bodysize + $PAGESIZE;
	while (($next = strpos($B, "\n", $pos)) !== false) {
	    $parts++;
	    $poses[$parts] = $next;
	    $pos = $next + $PAGESIZE;
	}
	$poses[$parts + 1] = $fullsize;
    }
}


wmlstart($CACHE_MAX_AGE);

echo "<card id=\"mailbody\">\n";

if (!$attid && $part == 1) {	//  first page of an ordinary mail...

	echo "<p mode=\"nowrap\"><small>\n";
	echo "<b>"._('From').":</b> $from<br/>\n";
	if (!empty($fromname))
	    echo "<b>"._('Name').":</b> $fromname<br/>\n";

	echo "<b>"._('Subj').":</b> $subject<br/>\n";
	echo "<b>"._('Date').":</b> $msgdate<br/>\n";
	echo "<b>"._('Size').":</b> $bodysize<br/>\n";

	if ($num_att > 0) {
	    if ($parts == 1)
		echo "<b>"._('Attachments').": $num_att</b> ("._('see below').")";
	    elseif ($poses[$attpart] < $bodysize)
		//  attaches sit at the bottom of $attpart page...
		echo "<b>"._('Attachments').": $num_att</b> ("._('see at page')." $attpart)";
	    else {	//  attaches start from the new page...
		echo "<b>";
		wmllink(_('Attachments').": $num_att","view.php",
				array("part"=>$attpart,"attid"=>0,
					"page"=>$page,"uid"=>$uid));
		echo "</b>\n";
	    }
	}
	echo "</small></p>\n";
}

if ( $parts == 1 ) {

	echo "<p mode=\"wrap\"><small>\n";
	echo $B;
	echo "</small></p>\n";

} else {

	echo "<p mode=\"wrap\"><small>\n";
	echo "<b>"._('Part').":</b> $part/$parts<br/>\n";

	$start = $poses[$part];
	$length = $poses[$part + 1] - $start;
	echo  substr($B, $start, $length);

	echo "</small></p>\n";
}


if ($part < $parts)
    wmlbutton(_('Next'),"view.php",array("part"=>$next_part,"attid"=>$attid,
					"page"=>$page,"uid"=>$uid));

if ($attid)
    wmlbutton(_('BACK'),"view.php",array("part"=>1,"attid"=>0,
					"page"=>$page,"uid"=>$uid));

wmlbutton(_('LIST'),"list.php",array("page"=>$page));

if ($parts > 1)
    wmlbutton(_('Pages'),"#pages",NULL);

if ($num_att > 0 && $attpart > 1)
    wmlbutton(_('Attachments'),"view.php",array("part"=>$attpart,"attid"=>0,
						"page"=>$page,"uid"=>$uid));

if (!$attid) {
    wmlbutton(_('Delete'),"list.php",
			    array("delete"=>1,"page"=>$page,"uid"=>$uid));
    wmlbutton(_('Reply'),"compose.php",array("page"=>$page,"uid"=>$uid));
    wmlbutton(_('Forward'),"compose.php",
			    array("page"=>$page,"uid"=>$uid,"fwd"=>1));
}
wmlbutton(_('INDEX'),"index.php",NULL);

echo "</card>\n";


if ($parts > 1) {

    echo "<card id=\"pages\">\n";
    echo "<p><small>"._('Pages').":<br/>\n";

    $max = ceil($PAGESIZE / 300);	//  don`t ask me why... :)

    if ($parts <= $max) {
	for ($i = 1; $i <= $parts; $i++) {
	    if ($i == $part)
		echo "<b>$part/$parts</b>\n";
	    else
		wmllink($i."/".$parts,"view.php",
				array("part"=>$i,"attid"=>$attid,
					"page"=>$page,"uid"=>$uid));
	    echo "<br/>\n";
	}
    }
    else {
	if ($max >= 5)
	    $p = array("1",$prev_part,$part,$next_part,$parts);
	else
	    $p = array("1",$part,$parts);
	$p = array_unique($p);
	asort($p);

	foreach ($p as $i) {
	    if ($i == 0)  continue;	//  may be by $prev_part...
	    if ($i > $parts)  continue;	//  may be by $next_part...
	    if ($i == $part)
		echo "<b>$part/$parts</b>\n";
	    else
		wmllink($i."/".$parts,"view.php",
				array("part"=>$i,"attid"=>$attid,
					"page"=>$page,"uid"=>$uid));
	    echo "<br/>\n";
	}

	if ($part > 1)  $val = $prev_part;
	else  $val = $next_part;
	echo _('Page number') . ":<br>";
	echo "<input format=\"*N\" size=\"7\" name=\"part\" value=\"$val\"/>\n";
	wmllink(_('Go'),"view.php",array("part"=>"$(part)","attid"=>$attid,
					    "page"=>$page,"uid"=>$uid));
    }

    echo "</small></p>\n";

    wmlbutton(_('BACK'),"#mailbody",NULL);

    echo "</card>\n";
}


wmlend();
?>
